import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

const configuration = {
  'defaultValues': {
    'package:flutter/src/cupertino/route.dart:CupertinoDialogRoute:transitionBuilder': buildCupertinoDialogTransitions,
    'package:flutter/src/cupertino/sliding_segmented_control.dart:CupertinoSlidingSegmentedControl:thumbColor':
        kThumbColor,
  },
};

final Animatable<double> _dialogScaleTween =
    Tween<double>(begin: 1.3, end: 1.0).chain(CurveTween(curve: Curves.linearToEaseOut));

Widget buildCupertinoDialogTransitions(
    BuildContext context, Animation<double> animation, Animation<double> secondaryAnimation, Widget child) {
  final fadeAnimation = CurvedAnimation(parent: animation, curve: Curves.easeInOut);
  if (animation.status == AnimationStatus.reverse) return FadeTransition(opacity: fadeAnimation, child: child);
  return FadeTransition(
      opacity: fadeAnimation, child: ScaleTransition(scale: animation.drive(_dialogScaleTween), child: child));
}

const CupertinoDynamicColor kThumbColor = CupertinoDynamicColor.withBrightness(
  color: Color(0xFFFFFFFF),
  darkColor: Color(0xFF636366),
);
