import 'dart:async';

import 'package:analyzer/dart/element/element.dart';
import 'package:analyzer/dart/element/visitor.dart';
import 'package:build/build.dart';
import 'package:flutterx_reflection_codegen/src/encoder/top_level/encoder_library.dart';
import 'package:flutterx_reflection_codegen/src/writer_framework.dart';
import 'package:source_gen/source_gen.dart';

part 'builder_generator_framework_parser.dart';

class FrameworkGenerator extends Generator {
  final parser = FrameworkParser();

  @override
  Future<String> generate(LibraryReader library, BuildStep buildStep) async {
    try {
      return await parser.parse(library.element, buildStep);
    } catch (e, stack) {
      print('$e\n$stack');
      rethrow;
    }
  }
}
