part of 'builder_generator.dart';

class FrameworkParser extends SimpleElementVisitor {
  final FrameworkWriter _writer = FrameworkWriter();

  Future<String> parse(LibraryElement current, BuildStep buildStep) async {
    _writer.initialize(current);
    final libraries = await buildStep.resolver.libraries.toList();
    LibraryEncoder.initialize(libraries);
    for (final library in libraries) library.visitChildren(this);
    return _writer.serialize(current);
  }

  @override
  void visitCompilationUnitElement(CompilationUnitElement element) => element.visitChildren(this);

  @override
  void visitClassElement(ClassElement element) => _writer.load(element);
}
