part of '../source_encoder.dart';

class NeverElementEncoder extends ElementEncoder<NeverElementImpl> {
  static const NeverElementEncoder instance = NeverElementEncoder._();

  const NeverElementEncoder._() : super._(sdk.flutter_never);

  @override
  void load(Map<String, Element> elements, NeverElementImpl element) {
    final id = identifier(element);
    if (elements.containsKey(id)) return;
    elements[id] = element;
  }

  @override
  String identifier(NeverElementImpl element) => target.identifier();

  @override
  String reference(NeverElementImpl element) => element.name!;

  @override
  String referenceDeclaration(NeverElementImpl element) => reference(element);

  @override
  String variable(NeverElementImpl element) => identifier(element);

  @override
  String declaration(NeverElementImpl element) =>
      DeclarationBuilder(kFlutterNever, identifier(element)).build(variable: variable(element));
}
