part of '../source_encoder.dart';

class VoidElementEncoder extends ElementEncoder<VoidElementWrapper> {
  static const VoidElementEncoder instance = VoidElementEncoder._();

  const VoidElementEncoder._() : super._(sdk.flutter_void);

  @override
  void load(Map<String, Element> elements, VoidElementWrapper element) {
    final id = identifier(element);
    if (elements.containsKey(id)) return;
    elements[id] = element;
  }

  @override
  String identifier(VoidElementWrapper element) => target.identifier();

  @override
  String reference(VoidElementWrapper element) => element.name;

  @override
  String referenceDeclaration(VoidElementWrapper element) => reference(element);

  @override
  String variable(VoidElementWrapper element) => identifier(element);

  @override
  String declaration(VoidElementWrapper element) =>
      DeclarationBuilder(kFlutterVoid, identifier(element)).build(variable: variable(element));
}
