enum sdk {
  flutter_type_token,
  flutter_class,
  flutter_constructor,
  flutter_instance_provider,
  flutter_parameter,
  flutter_dynamic,
  flutter_enum,
  flutter_function,
  flutter_type_alias,
  flutter_type_parameter,
  flutter_void,
  flutter_never,
}

const String kFlutterParameter = '_Kp';
const String kDefaultValueResolver = '_Dr';
const String kFlutterType = '_Ft';
const String kDefinedType = '_Dt';
const String kFlutterTypeAlias = '_Ta';
const String kRawFlutterTypeAlias = '_Ra';
const String kParametrizedFlutterTypeAlias = '_Pa';
const String kFlutterClass = '_Fk';
const String kRawFlutterClass = '_Rk';
const String kParametrizedFlutterClass = '_Pk';
const String kFlutterConstructor = '_Kc';
const String kFlutterField = '_If';
const String kFactoryContext = '_Kx';
const String kInstanceProvider = '_Ip';
const String kParameterReader = '_Pr';
const String kFlutterDynamic = '_Kd';
const String kFlutterEnum = '_Ke';
const String kFlutterFunction = '_Kf';
const String kRawFlutterFunction = '_Rf';
const String kParametrizedFlutterFunction = '_Pf';
const String kFunctionContext = '_Fx';
const String kFlutterNever = '_Fz';
const String kFlutterTypeParameter = '_Fg';
const String kTypeToken = '_T';
const String kFlutterVoid = '_Fv';

const String kString = 'String';
const String kList = 'List';
const String kSet = 'Set';
const String kMap = 'Map';
const String kDynamic = 'dynamic';
const String kFunction = 'Function';

extension SdkExt on sdk {
  String get _variableId {
    switch (this) {
      case sdk.flutter_type_token:
        return '_t';
      case sdk.flutter_class:
        return '_k';
      case sdk.flutter_constructor:
        return '_c';
      case sdk.flutter_instance_provider:
        return '_i';
      case sdk.flutter_parameter:
        return '_p';
      case sdk.flutter_dynamic:
        return '_d';
      case sdk.flutter_enum:
        return '_e';
      case sdk.flutter_function:
        return '_f';
      case sdk.flutter_type_alias:
        return '_a';
      case sdk.flutter_type_parameter:
        return '_g';
      case sdk.flutter_void:
        return '_v';
      case sdk.flutter_never:
        return '_z';
    }
  }

  String identifier([Object? id1, Object? id2, Object? id3]) {
    final prefix = _variableId;
    final out = StringBuffer(prefix);
    if (id1 != null) {
      out.write(id1);
      if (id2 != null) {
        out.write(id2);
        if (id3 != null) {
          out.write(id3);
        }
      }
    }
    final data = out.toString();
    final id = _ids[data];
    if (id != null) return id;
    final g = (_idGenerator[prefix] ?? -1) + 1;
    _idGenerator[prefix] = g;
    final result = '$prefix${g.toRadixString(26)}';
    _ids[data] = result;
    return result;
  }

  static final Map<String, int> _idGenerator = {};
  static final Map<String, String> _ids = {};
}
