part of '../source_encoder.dart';

class DynamicTypeEncoder extends TypeEncoder<DynamicType> {
  static const DynamicTypeEncoder instance = DynamicTypeEncoder._();

  @override
  DynamicElementEncoder get elementEncoder => DynamicElementEncoder.instance;

  const DynamicTypeEncoder._() : super._(sdk.flutter_dynamic);

  @override
  void load(Map<String, Element> elements, DynamicType type) =>
      elementEncoder.load(elements, type.element as DynamicElementImpl);

  @override
  String identifier(DynamicType type) => elementEncoder.identifier(type.element as DynamicElementImpl);

  @override
  String reference(DynamicType type) => elementEncoder.reference(type.element as DynamicElementImpl);

  @override
  String referenceDeclaration(DynamicType type) =>
      elementEncoder.referenceDeclaration(type.element as DynamicElementImpl);

  @override
  String variable(DynamicType type) => elementEncoder.variable(type.element as DynamicElementImpl);
}
