part of '../source_encoder.dart';

class EnumTypeEncoder extends TypeEncoder<InterfaceType> {
  static const EnumTypeEncoder instance = EnumTypeEncoder._();

  @override
  EnumElementEncoder get elementEncoder => EnumElementEncoder.instance;

  const EnumTypeEncoder._() : super._(sdk.flutter_enum);

  @override
  void load(Map<String, Element> elements, InterfaceType type) =>
      elementEncoder.load(elements, type.element as EnumElementImpl);

  @override
  String identifier(InterfaceType type) =>
      elementEncoder.identifier(type.element as EnumElementImpl) + nullabilityIdentifier(type);

  @override
  String reference(InterfaceType type) =>
      elementEncoder.reference(type.element as EnumElementImpl) + nullabilitySuffix(type);

  @override
  String referenceDeclaration(InterfaceType type) =>
      elementEncoder.referenceDeclaration(type.element as EnumElementImpl) + nullabilitySuffix(type);

  @override
  String variable(InterfaceType type) => elementEncoder.variable(type.element as EnumElementImpl);
}
