part of '../source_encoder.dart';

class FunctionTypeEncoder extends TypeEncoder<FunctionType> {
  static const FunctionTypeEncoder instance = FunctionTypeEncoder._();

  @override
  FunctionElementEncoder get elementEncoder => FunctionElementEncoder.instance;

  const FunctionTypeEncoder._() : super._(sdk.flutter_function);

  @override
  void load(Map<String, Element> elements, FunctionType type) =>
      elementEncoder.load(elements, FunctionTypedElementWrapper(type));

  @override
  String identifier(FunctionType type) =>
      elementEncoder.identifier(FunctionTypedElementWrapper(type)) + nullabilityIdentifier(type);

  @override
  String reference(FunctionType type) =>
      elementEncoder.reference(FunctionTypedElementWrapper(type)) + nullabilitySuffix(type);

  @override
  String referenceDeclaration(FunctionType type) =>
      elementEncoder.referenceDeclaration(FunctionTypedElementWrapper(type)) + nullabilitySuffix(type);

  @override
  String variable(FunctionType type) => elementEncoder.variable(FunctionTypedElementWrapper(type));
}
