part of '../source_encoder.dart';

class NeverTypeEncoder extends TypeEncoder<NeverType> {
  static const NeverTypeEncoder instance = NeverTypeEncoder._();

  @override
  NeverElementEncoder get elementEncoder => NeverElementEncoder.instance;

  const NeverTypeEncoder._() : super._(sdk.flutter_never);

  @override
  void load(Map<String, Element> elements, NeverType type) =>
      elementEncoder.load(elements, type.element as NeverElementImpl);

  @override
  String identifier(NeverType type) => elementEncoder.identifier(type.element as NeverElementImpl);

  @override
  String reference(NeverType type) => elementEncoder.reference(type.element as NeverElementImpl);

  @override
  String referenceDeclaration(NeverType type) => elementEncoder.referenceDeclaration(type.element as NeverElementImpl);

  @override
  String variable(NeverType type) => elementEncoder.variable(type.element as NeverElementImpl);
}
