part of '../source_encoder.dart';

class TypeParameterTypeEncoder extends TypeEncoder<TypeParameterType> {
  static const TypeParameterTypeEncoder instance = TypeParameterTypeEncoder._();

  @override
  TypeParameterElementEncoder get elementEncoder => TypeParameterElementEncoder.instance;

  const TypeParameterTypeEncoder._() : super._(sdk.flutter_type_parameter);

  @override
  void load(Map<String, Element> elements, TypeParameterType type) => elementEncoder.load(elements, type.element);

  @override
  String identifier(TypeParameterType type) => elementEncoder.identifier(type.element) + nullabilityIdentifier(type);

  @override
  String reference(TypeParameterType type) => elementEncoder.reference(type.element) + nullabilitySuffix(type);

  @override
  String referenceDeclaration(TypeParameterType type) =>
      elementEncoder.referenceDeclaration(type.element) + nullabilitySuffix(type);

  @override
  String variable(TypeParameterType type) => elementEncoder.variable(type.element);
}
