part of '../source_encoder.dart';

class VoidTypeEncoder extends TypeEncoder<VoidType> {
  static const VoidTypeEncoder instance = VoidTypeEncoder._();

  @override
  VoidElementEncoder get elementEncoder => VoidElementEncoder.instance;

  const VoidTypeEncoder._() : super._(sdk.flutter_void);

  @override
  void load(Map<String, Element> elements, VoidType type) => elementEncoder.load(elements, VoidElementWrapper.instance);

  @override
  String identifier(VoidType type) => elementEncoder.identifier(VoidElementWrapper.instance);

  @override
  String reference(VoidType type) => elementEncoder.reference(VoidElementWrapper.instance);

  @override
  String referenceDeclaration(VoidType type) => elementEncoder.referenceDeclaration(VoidElementWrapper.instance);

  @override
  String variable(VoidType type) => elementEncoder.variable(VoidElementWrapper.instance);
}
