import 'package:analyzer/dart/element/element.dart';
import 'package:flutterx_reflection_codegen/src/encoder/source_encoder.dart';
import 'package:flutterx_reflection_codegen/src/encoder/top_level/encoder_framework.dart';

class FrameworkWriter {
  final Map<String, Element> _elements = {};
  late LibraryElement _current;

  LibraryElement get current => _current;

  Iterable<Element> get entries => _elements.values;

  void initialize(LibraryElement current) {
    _elements.clear();
    _current = current;
  }

  void load(ClassElement element) => ElementEncoder.of(element).load(_elements, element);

  String serialize(LibraryElement current) => FrameworkEncoder.instance.encode(this);
}
