part of '../flutterx_reflection.dart';

/// Flutter [dynamic] type
///
/// [token] @see [FlutterType.token]
/// [library] @see [DefinedType.library]
/// [exports] @see [DefinedType.exports]
/// [name] @see [FlutterType.name]
/// [referenceId] @see [DefinedType.referenceId]
/// [toString] @see [FlutterType.toString]
/// [isAssignableFrom] always true: every type can be assigned to dynamic. @see [FlutterType.isAssignableFrom]
@immutable
class FlutterDynamic implements FlutterType, DefinedType {
  @override
  TypeToken get token => const TypeToken<dynamic>();

  @override
  String get library => 'dart:core';

  @override
  Set<String> get exports => const {};

  @override
  String get name => 'dynamic';

  @override
  String get referenceId => DefinedType.generateReferenceId(this);

  const FlutterDynamic();

  @override
  String toString() => _describeFlutterType(this);

  @override
  bool isAssignableFrom(FlutterType other) => true;
}
